diff --git a/game/client/src/main/java/net/minecraft/client/gui/toasts/MusicToast.java b/game/client/src/main/java/net/minecraft/client/gui/toasts/MusicToast.java
new file mode 100644
index 000000000..fad74c07b
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/toasts/MusicToast.java
@@ -0,0 +1,85 @@
+package net.minecraft.client.gui.toasts;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class MusicToast
+    implements IToastable
+{
+    private static final double ANIMATION_DURATION_MILLIS = 6000L;
+    private long startTime;
+    private final @NotNull String title;
+    private final @Nullable String author;
+
+    public MusicToast(final @NotNull String title, final @Nullable String author) {
+        this.title = title;
+        this.author = author;
+    }
+
+    @Override
+    public boolean messageOnly(long runtime) {
+        return this.author == null;
+    }
+
+    @Override
+    public String getTitle(long runtime) {
+        return this.title;
+    }
+
+    @Override
+    public int titleColor(long runtime) {
+        return 0xFFFFFFFF;
+    }
+
+    @Override
+    public String getMessage(long runtime) {
+        if (this.author == null) {
+            return this.title;
+        } else {
+            return this.author;
+        }
+    }
+
+    @Override
+    public int messageColor(long runtime) {
+        if (this.author == null) {
+            return 0xFFFFFFFF;
+        } else {
+            return 0xFFAFAFAF;
+        }
+    }
+
+    @Override
+    public double getAnimationProgress(long runtime) {
+        runtime = System.currentTimeMillis() - startTime;
+        return runtime / ANIMATION_DURATION_MILLIS;
+    }
+
+    @Override
+    public String getTexture(long runtime) {
+        return "minecraft:gui/toast_music";
+    }
+
+    @Override
+    public void onToastStart() {
+        startTime = System.currentTimeMillis();
+    }
+
+    @Override
+    public void onToastEnd() {
+        // Do nothing
+    }
+
+    @Override
+    public boolean isEquivalentToast(@NotNull IToastable toast) {
+        return toast instanceof MusicToast;
+    }
+
+    @Override
+    public @Nullable ItemStack getIcon(long runtime) {
+        return Items.RECORD_CAT.getDefaultStack();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
index 700a1a729..0a3e3ccc9 100644
--- a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
+++ b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
@@ -2,6 +2,7 @@ package net.minecraft.client.input;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.KeyBinding;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -33,12 +34,12 @@ public class PlayerInput {
 		this.gameSettings = mc.gameSettings;
 	}
 
-	public void keyEvent(int keyCode, boolean pressed) {
+	public void keyEvent(int keyCode, int mouseCode, boolean pressed) {
 		if(mc.currentScreen != null) {
 			return;
 		}
 		
-		if(gameSettings.keySneak.isKeyboardKey(keyCode)) {
+		if(gameSettings.keySneak.isKeyOrMouse(keyCode, mouseCode)) {
 			if(gameSettings.sneakToggle.value && !mc.thePlayer.noPhysics) {
 				if(pressed) {
 					sneak = !sneak;
@@ -48,29 +49,29 @@ public class PlayerInput {
 			}
 		}
 		
-		if(gameSettings.keyForward.isKeyboardKey(keyCode)) {
+		if(gameSettings.keyForward.isKeyOrMouse(keyCode, mouseCode) ) {
 			pressedForward = pressed;
 			isAutoWalkOn = false;
 		}
-		if(gameSettings.keyBack.isKeyboardKey(keyCode)) {
+		if(gameSettings.keyBack.isKeyOrMouse(keyCode, mouseCode)) {
 			pressedBackward = pressed;
 			isAutoWalkOn = false;
 		}
-		if(gameSettings.keyLeft.isKeyboardKey(keyCode)) {
+		if(gameSettings.keyLeft.isKeyOrMouse(keyCode, mouseCode)) {
 			pressedLeft = pressed;
 		}
-		if(gameSettings.keyRight.isKeyboardKey(keyCode)) {
+		if(gameSettings.keyRight.isKeyOrMouse(keyCode, mouseCode)) {
 			pressedRight = pressed;
 		}
-		if(gameSettings.keyJump.isKeyboardKey(keyCode)) {
+		if(gameSettings.keyJump.isKeyOrMouse(keyCode, mouseCode)) {
 			pressedJump = pressed;
 		}
 
-		if(gameSettings.keyAutoWalk.isKeyboardKey(keyCode) && pressed) {
+		if(gameSettings.keyAutoWalk.isKeyOrMouse(keyCode, mouseCode) && pressed) {
 			isAutoWalkOn = true;
 		}
 
-		if(gameSettings.keyEasyBridge.isKeyboardKey(keyCode) && pressed) {
+		if(gameSettings.keyEasyBridge.isKeyOrMouse(keyCode, mouseCode) && pressed) {
 			gameSettings.easyBridge.toggle();
 			mc.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.easyBridge);
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index ddd128978..9d8490f35 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -14,6 +14,7 @@ import com.mojang.logging.LogUtils;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
+import net.minecraft.client.enums.MusicFrequency;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.options.ScreenOptions;
@@ -136,6 +137,8 @@ public class GameSettings {
 	public OptionBoolean turnWithVehicle = new OptionBoolean(this, "turnWithVehicle", true);
 	public OptionBoolean disableCrashHandler = new OptionBoolean(this, "disableCrashHandler", false);
 	public OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", true);
+	public OptionBoolean musicToasts = new OptionBoolean(this, "musicToasts", true);
+	public OptionEnum<MusicFrequency> musicFrequency = new OptionEnum<>(this, "musicFrequency", MusicFrequency.class, MusicFrequency.DEFAULT);
 
 	public OptionBoolean enableDevResourceLoading = new OptionBoolean(this, "enableDevResourceLoading", false);
 	public OptionBoolean downloadSoundfiles = new OptionBoolean(this, "downloadSoundfiles", true);
@@ -538,6 +541,9 @@ public class GameSettings {
 			mc.textureManager.refreshTexturesAndDisplayErrors();
 			mc.renderGlobal.allChanged();
 		}
+		if(option == musicFrequency) {
+			mc.sndManager.resetMusicTicks();
+		}
 	}
 
 	public void loadOptions() {
diff --git a/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java b/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java
index 6d5f29970..f38de4f2f 100644
--- a/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java
+++ b/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java
@@ -178,6 +178,10 @@ public class KeyBinding {
 		}
 		return false;
 	}
+
+	public boolean isKeyOrMouse(int key, int button) {
+		return isKeyboardKey(key) || isMouseButton(button);
+	}
 	
 	public boolean isBound() {
 		return inputDevice != null;
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionVolume.java b/game/client/src/main/java/net/minecraft/client/option/OptionVolume.java
index 9bfb1b8d0..159567b38 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionVolume.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionVolume.java
@@ -1,11 +1,14 @@
 package net.minecraft.client.option;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.sound.SoundCategoryHelper;
 import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.core.sound.SoundCategory;
+import org.slf4j.Logger;
 import paulscode.sound.SoundSystem;
 
 public class OptionVolume extends OptionFloat {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public final SoundCategory soundCategory;
 
 	//do *not* add @NotNull to gameSettings here, breaks modding for some abstract reason
@@ -19,12 +22,16 @@ public class OptionVolume extends OptionFloat {
 		super.onUpdate();
 		gameSettings.mc.sndManager.updateOptions();
 		SoundSystem soundSystem = SoundEngine.getSoundSystem();
-		if (soundSystem != null) {
-			if (soundCategory != SoundCategory.GUI_SOUNDS && !soundSystem.playing("sound_audio_options")) {
-				gameSettings.mc.sndManager.playSoundWithID(soundCategory.changedSound, soundCategory, 1f, 1f, "sound_audio_options");
-			} else if (soundCategory != SoundCategory.GUI_SOUNDS) {
-				soundSystem.setVolume("sound_audio_options", SoundCategoryHelper.getEffectiveVolume(soundCategory, gameSettings));
+		try {
+			if (soundSystem != null) {
+				if (soundCategory != SoundCategory.GUI_SOUNDS && !soundSystem.playing("sound_audio_options")) {
+					gameSettings.mc.sndManager.playSoundWithID(soundCategory.changedSound, soundCategory, 1f, 1f, "sound_audio_options");
+				} else if (soundCategory != SoundCategory.GUI_SOUNDS) {
+					soundSystem.setVolume("sound_audio_options", SoundCategoryHelper.getEffectiveVolume(soundCategory, gameSettings));
+				}
 			}
+		} catch (Exception e) { // Not sure why but this block of code, specifically the `soundSystem.playing("sound_audio_options")` line seems to be able to through an NPE *sometimes* for *some* users.
+			LOGGER.error("Unexpected error occurred while trying to preview sounds! This is a poorly known issue please report!", e);
 		}
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 738044ccb..27ef2c4b5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -96,7 +96,7 @@ public class TextureManager {
 		addNativeDynamicTextures(this.mc.gameSettings.animations.value);
 		if (this.mc.gameSettings.customAnimations.value && this.mc.gameSettings.animations.value == ANIMATIONS_CUSTOM) {
 			try {
-				loadCustomAnimations();
+				loadCustomAnimations(errors);
 			}catch (final TexturePackException e) {
 				errors.add(e);
 			}
@@ -144,16 +144,20 @@ public class TextureManager {
 		dynamicTextures.put(texture.targetTexture.namespaceId.namespace() + ":" + TextureRegistry.stitcherMapReverse.get(texture.targetTexture.parentAtlas) + "/" + texture.targetTexture.namespaceId.value(), texture);
 	}
 
-	private void loadCustomAnimations() {
+	private void loadCustomAnimations(final Collection<? super Throwable> errors) {
 		if(!this.mc.gameSettings.customAnimations.value) {
 			return;
 		}
 
 		for (final AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
 			for (final IconCoordinate c : stitcher.textureMap.values()) {
-				if (c.hasMeta("animation")) {
-                    LOGGER.debug("Icon '{}' has 'animation' meta!", c.namespaceId);
-					addDynamicTextureOverride(new DynamicTextureCustom(c, c.getMeta("animation", AnimationProperties.class)), true);
+				try {
+					if (c.hasMeta("animation")) {
+						LOGGER.debug("Icon '{}' has 'animation' meta!", c.namespaceId);
+						addDynamicTextureOverride(new DynamicTextureCustom(c, c.getMeta("animation", AnimationProperties.class)), true);
+					}
+				} catch (final TexturePackException e) {
+					errors.add(e);
 				}
 			}
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 1de314f21..67d096a7a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -574,6 +574,10 @@ public class WorldRenderer
             }
             systemTime = System.nanoTime();
         }
+
+        // Render toasts
+        mc.guiToasts.render(partialTick);
+
         if(mc.currentScreen != null)
         {
             Debug.change("gui");
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index 73c7317a7..2cfc6e101 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -4,6 +4,8 @@ import net.minecraft.client.render.LightingCache;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
diff --git a/game/client/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java b/game/client/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
index 401c47fe8..019e7433e 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
@@ -10,6 +10,7 @@ import com.google.gson.JsonParser;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.File;
 import java.io.InputStream;
@@ -161,6 +162,8 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
                 event,
                 pack,
                 path,
+                null,
+                null,
                 1f,
                 1f,
                 1,
@@ -173,6 +176,16 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
     public SoundEntry getSoundEntry(SoundEvent event, TexturePack pack, JsonObject jObj) throws JsonParseException {
         String name = jObj.get("name").getAsString(); // Required
 
+        @Nullable String title = null;
+        if (jObj.has("title")) {
+            title = jObj.get("title").getAsString();
+        }
+
+        @Nullable String author = null;
+        if (jObj.has("author")) {
+            author = jObj.get("author").getAsString();
+        }
+
         float volume = 1;
         if (jObj.has("volume")) {
             volume = jObj.get("volume").getAsFloat();
@@ -213,6 +226,8 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
                 event,
                 pack,
                 name,
+                title,
+                author,
                 volume,
                 pitch,
                 weight,
diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
index 4d478c4bb..e49746bff 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -8,6 +8,7 @@ import java.util.concurrent.locks.ReentrantLock;
 import com.mojang.logging.LogUtils;
 import net.betterthanadventure.sound.LibraryLWJGL3OpenAL;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.toasts.MusicToast;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
@@ -22,7 +23,6 @@ import paulscode.sound.codecs.CodecWav;
 public class SoundEngine
 {
 	private static final Logger LOGGER = LogUtils.getLogger();
-	private static final int MUSIC_INTERVAL = 6000;
 	private static @Nullable SoundSystem soundSystem;
 	private static Lock lock = new ReentrantLock();
 	private static boolean loaded = false;
@@ -40,9 +40,12 @@ public class SoundEngine
 	public SoundEngine() {
         this.idCounter = 0;
         this.random = new Random();
-        this.ticksBeforeMusic = this.random.nextInt(MUSIC_INTERVAL);
     }
 
+	public void resetMusicTicks() {
+		this.ticksBeforeMusic = this.options.musicFrequency.value.interval == 0 ? 0 : this.random.nextInt(this.options.musicFrequency.value.interval);
+	}
+
 	public void destroy() {
 		try {
 			lock.lock();
@@ -102,6 +105,7 @@ public class SoundEngine
 		try {
 			lock.lock();
 			this.options = gamesettings;
+			this.resetMusicTicks();
 			if (!isLoaded() && SoundCategoryHelper.isAnyEnabled(gamesettings)) {
 				loadLibrary();
 			}
@@ -152,11 +156,16 @@ public class SoundEngine
 				if (event == null) return;
 				final SoundEntry entry = event.getRandomEntry();
 				if (entry != null) {
-					this.ticksBeforeMusic = this.random.nextInt(MUSIC_INTERVAL) + MUSIC_INTERVAL;
+					this.resetMusicTicks();
+					this.ticksBeforeMusic += this.options.musicFrequency.value.interval;
 					soundSystem.backgroundMusic(BG_MUSIC, entry.getURL(), entry.name, false);
 					soundSystem.setPitch(BG_MUSIC, entry.pitch);
 					soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, this.options) * entry.volume);
 					soundSystem.play(BG_MUSIC);
+
+					if (this.options.musicToasts.value && entry.title != null) {
+						mc.guiToasts.addToast(new MusicToast(entry.title, entry.author));
+					}
 				}
 			}
 		} catch (Exception e) {
diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundEntry.java b/game/client/src/main/java/net/minecraft/client/sound/SoundEntry.java
index a0f905a64..7a175cf74 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundEntry.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundEntry.java
@@ -14,6 +14,9 @@ public class SoundEntry {
 
     public final @NotNull String name;
 
+    public final @Nullable String title;
+    public final @Nullable String author;
+
     /**
      * Weight of entry in random bag
      */
@@ -50,6 +53,8 @@ public class SoundEntry {
         (
         @NotNull SoundEvent parentEvent, @NotNull TexturePack pack,
         @NotNull String name,
+        @Nullable String title,
+        @Nullable String author,
         float volume,
         float pitch,
         int weight,
@@ -61,6 +66,8 @@ public class SoundEntry {
         this.parent = parentEvent;
         this.pack = pack;
         this.name = name;
+        this.title = title;
+        this.author = author;
         this.volume = volume;
         this.pitch = pitch;
         this.weight = weight;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index 9e19c4a8f..5cb8453d7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -2,12 +2,14 @@ package net.minecraft.core.block;
 
 import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.generate.feature.WorldFeatureOre;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.HashMap;
@@ -30,52 +32,37 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
 		}
 		
 		if (world.areBlocksLoaded(x, y, z, 16)) {
-			if (canMossSpread(world, x, y, z) && rand.nextInt(20) == 0) {
-				spreadMossRandomly(world, x, y, z, rand, false);
-			}
-		}
-	}
-	
-	public boolean spreadMossRandomly(World world, int x, int y, int z, Random random, boolean ignoreLight) {
-		int mossX = x, mossY = y, mossZ = z;
-//		{
-//			//Moss grows in a 3x5x3
-//			x1 = (x + random.nextInt(3)) - 1;
-//			y1 = (y + random.nextInt(5)) - 3;
-//			z1 = (z + random.nextInt(3)) - 1;
-//		}
-		{
-			//Moss only grows to neighbor blocks
-			int side = random.nextInt(6);
-			if(side == 0) mossZ--; //North
-			if(side == 1) mossX++; //East
-			if(side == 2) mossZ++; //South
-			if(side == 3) mossX--; //West
-			if(side == 4) mossY++; //Up
-			if(side == 5) mossY--; //Down
-		}
-		
-		if (ignoreLight || !Block.isBuried(world, mossX, mossY, mossZ)) {
-			Block<?> mossStone = getMossBlock(world.getBlockId(mossX, mossY, mossZ));
-			if (mossStone != null) {
-				world.setBlockWithNotify(mossX, mossY, mossZ, mossStone.id());
-				return true;
+			if (rand.nextInt(20) == 0 && airExposed(world, x, y, z)) {
+				Side randomSide = Side.getSideById(rand.nextInt(6));
+				int rX = x + randomSide.getOffsetX();
+				int rY = y + randomSide.getOffsetY();
+				int rZ = z + randomSide.getOffsetZ();
+				if (canMossSpread(world, rX, rY, rZ)) {
+					Block<?> mossStone = getMossBlock(world.getBlockId(rX, rY, rZ));
+					if (mossStone != null) {
+						world.setBlockWithNotify(rX, rY, rZ, mossStone.id());
+					}
+				}
 			}
 		}
-		
-		return false;
 	}
+
 	
 	public boolean canMossSpread(World world, int x, int y, int z) {
-		for (int i = 0; i < 6; i++) {
-			Side side = Side.getSideById(i);
-			if (world.getBlockLightValue(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ()) <= 5 && world.isBlockLoaded(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ())) continue;
-			return false;
+		if (!world.isBlockLoaded(x, y, z)) return false;
+		int maxBlockLight = 0;
+		int maxSkyLight = 0;
+		for (int i = 0; i < Side.sides.length; i++) {
+			Side s = Side.sides[i];
+			int blockLight = world.getBlockLightValue(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ());
+			int skyLight = world.getSavedLightValue(LightLayer.Sky, x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ());
+			if (blockLight > maxBlockLight) { maxBlockLight = blockLight; }
+			if (skyLight > maxSkyLight) { maxSkyLight = skyLight; }
 		}
-		return true;
+		return maxBlockLight == 0 && maxSkyLight == 0;
 	}
 
-	public static Block<?> getMossBlock(int blockId) {
+	public static @Nullable Block<?> getMossBlock(int blockId) {
 		if (blockId == 0)
 			return null;
 		return getMossBlock(Blocks.blocksList[blockId]);
@@ -119,56 +106,47 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
 	public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(!world.isClientSide)
 		{
+			if (!canMossSpread(world, blockX, blockY, blockZ) || !airExposed(world, blockX, blockY, blockZ)) return false;
 			if (player == null || player.getGamemode().consumeBlocks())
 			{
 				itemstack.stackSize--;
 			}
 			for(int j1 = 0; j1 < 32; j1++)
 			{
-				int k1 = blockX;
-				int l1 = blockY;
-				int i2 = blockZ;
+				int randomBlockX = blockX;
+				int randomBlockY = blockY;
+				int randomBlockZ = blockZ;
 				for(int j2 = 0; j2 < j1 / 16; j2++)
 				{
-					k1 += world.rand.nextInt(3) - 1;
-					l1 += ((world.rand.nextInt(3) - 1) * world.rand.nextInt(3)) / 2;
-					i2 += world.rand.nextInt(3) - 1;
+					randomBlockX += world.rand.nextInt(3) - 1;
+					randomBlockY += ((world.rand.nextInt(3) - 1) * world.rand.nextInt(3)) / 2;
+					randomBlockZ += world.rand.nextInt(3) - 1;
 				}
 
-				if(Block.isBuried(world, k1, l1, i2))
+				if(!airExposed(world, randomBlockX, randomBlockY, randomBlockZ))
 				{
 					continue;
 				}
 
-				if(world.getBlockLightValue(k1, l1 + 1, i2) > 5 ||
-						world.getBlockLightValue(k1, l1 - 1, i2)  > 5 ||
-						world.getBlockLightValue(k1 + 1, l1 , i2)  > 5 ||
-						world.getBlockLightValue(k1 - 1, l1 , i2)  > 5 ||
-						world.getBlockLightValue(k1, l1 , i2 - 1)  > 5 ||
-						world.getBlockLightValue(k1, l1 , i2 + 1)  > 5)
-				{
+				if(!canMossSpread(world,randomBlockX, randomBlockY, randomBlockZ)) {
 					continue;
 				}
 
-				int blockId = world.getBlockId(k1, l1, i2);
-				if(blockId == Blocks.STONE.id())
-					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_STONE.id());
-				else if(blockId == Blocks.LIMESTONE.id())
-					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_LIMESTONE.id());
-				else if(blockId == Blocks.GRANITE.id())
-					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_GRANITE.id());
-				else if(blockId == Blocks.BASALT.id())
-					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_BASALT.id());
-				else if(blockId == Blocks.COBBLE_STONE.id())
-					world.setBlockWithNotify(k1, l1, i2, Blocks.COBBLE_STONE_MOSSY.id());
-				else if(blockId == Blocks.BRICK_STONE_POLISHED.id())
-					world.setBlockWithNotify(k1, l1, i2, Blocks.BRICK_STONE_POLISHED_MOSSY.id());
-				else if(blockId == Blocks.LOG_OAK.id())
-					world.setBlockWithNotify(k1, l1, i2, Blocks.LOG_OAK_MOSSY.id());
-
+				Block block = getMossBlock(world.getBlockId(randomBlockX, randomBlockY, randomBlockZ));
+				if (block != null) {
+					world.setBlockWithNotify(randomBlockX, randomBlockY, randomBlockZ, block.id());
+				}
 			}
 
 		}
 		return true;
 	}
+
+	public boolean airExposed(@NotNull World world, int x, int y, int z) {
+		for (int i = 0; i < Side.sides.length; i++) {
+			Side s = Side.sides[i];
+			if (world.isAirBlock(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ())) return true;
+		}
+		return false;
+	}
 }
